var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const phin = require("phin")
    .defaults({ "parse": "json", "timeout": 12000 });
const GET_ASSETS = "https://www.bloxworld.xyz/api/avatar?id=";
function getNonEmptyHats(assets) {
    const hats = [];
    for (let i = 0; i < 5; i++) {
        if (hats.length >= 3)
            break;
        const hat = assets.hats[i];
        if (hat)
            hats.push(hat);
    }
    return hats;
}
function setAvatar(p, userId) {
    return __awaiter(this, void 0, void 0, function* () {
console.log(userId)
console.log(GET_ASSETS + userId)
        const data = (yield phin({ url: GET_ASSETS + userId })).body;
	 
        if (data.error)
            throw new Error(data.error.message);
        p.colors.head = "#" + data.head_color;
        p.colors.torso = "#" + data.torso_color;
        p.colors.leftArm = "#" + data.left_arm_color;
        p.colors.rightArm = "#" + data.right_arm_color;
        p.colors.leftLeg = "#" + data.left_leg_color;
        p.colors.rightLeg = "#" + data.right_leg_color;
        p.assets.tool = data.tool;
        p.assets.face = data.face;
        p.assets.tshirt = data.tshirt;
        p.assets.shirt = data.shirt;
        p.assets.pants = data.pants;
        p.assets.hat1 = data.hat1;
        p.assets.hat2 = data.hat2;
        p.assets.hat3 = data.hat3;

        return true;
    });
}
module.exports = setAvatar;
